# Class PixelInterleavedSampleModel

java.lang.Object
java.awt.image.SampleModel
java.awt.image.ComponentSampleModel
java.awt.image.PixelInterleavedSampleModel

public class PixelInterleavedSampleModel extends ComponentSampleModel
This class represents image data which is stored in a pixel interleaved fashion and for which each sample of a pixel occupies one data element of the DataBuffer. It subclasses ComponentSampleModel but provides a more efficient implementation for accessing pixel interleaved image data than is provided by ComponentSampleModel. This class stores sample data for all bands in a single bank of the DataBuffer. Accessor methods are provided so that image data can be manipulated directly. Pixel stride is the number of data array elements between two samples for the same band on the same scanline. Scanline stride is the number of data array elements between a given sample and the corresponding sample in the same column of the next scanline. Band offsets denote the number of data array elements from the first data array element of the bank of the DataBuffer holding each band to the first sample of the band. The bands are numbered from 0 to N-1. Bank indices denote the correspondence between a bank of the data buffer and a band of image data. This class supports `TYPE_BYTE`, `TYPE_USHORT`, `TYPE_SHORT`, `TYPE_INT`, `TYPE_FLOAT` and `TYPE_DOUBLE` datatypes.

## Field Summary

### Fields declared in class ComponentSampleModel

`bandOffsets, bankIndices, numBands, numBanks, pixelStride, scanlineStride`
Modifier and Type
Field
Description
`protected int[]`
`bandOffsets`
Offsets for all bands in data array elements.
`protected int[]`
`bankIndices`
Index for each bank storing a band of image data.
`protected int`
`numBands`
The number of bands in this `ComponentSampleModel`.
`protected int`
`numBanks`
The number of banks in this `ComponentSampleModel`.
`protected int`
`pixelStride`
Pixel stride (in data array elements) of the region of image data described by this ComponentSampleModel.
`protected int`
`scanlineStride`
Line stride (in data array elements) of the region of image data described by this ComponentSampleModel.

### Fields declared in class SampleModel

`dataType, height, width`
Modifier and Type
Field
Description
`protected int`
`dataType`
Data type of the DataBuffer storing the pixel data.
`protected int`
`height`
Height in pixels of the region of image data that this SampleModel describes.
`protected int`
`width`
Width in pixels of the region of image data that this SampleModel describes.

## Constructor Summary

Constructors
Constructor
Description
`PixelInterleavedSampleModel(int dataType, int w, int h, int pixelStride, int scanlineStride, int[] bandOffsets)`
Constructs a PixelInterleavedSampleModel with the specified parameters.

## Method Summary

Modifier and Type
Method
Description
`SampleModel`
`createCompatibleSampleModel(int w, int h)`
Creates a new PixelInterleavedSampleModel with the specified width and height.
`SampleModel`
`createSubsetSampleModel(int[] bands)`
Creates a new PixelInterleavedSampleModel with a subset of the bands of this PixelInterleavedSampleModel.

### Methods declared in class ComponentSampleModel

`createDataBuffer, getBandOffsets, getBankIndices, getDataElements, getNumDataElements, getOffset, getOffset, getPixel, getPixels, getPixelStride, getSample, getSampleDouble, getSampleFloat, getSamples, getSampleSize, getSampleSize, getScanlineStride, setDataElements, setPixel, setPixels, setSample, setSample, setSample, setSamples`
Modifier and Type
Method
Description
`DataBuffer`
`createDataBuffer()`
Creates a `DataBuffer` that corresponds to this `ComponentSampleModel`.
`final int[]`
`getBandOffsets()`
Returns the band offset for all bands.
`final int[]`
`getBankIndices()`
Returns the bank indices for all bands.
`Object`
`getDataElements(int x, int y, Object obj, DataBuffer data)`
Returns data for a single pixel in a primitive array of type `TransferType`.
`final int`
`getNumDataElements()`
Returns the number of data elements needed to transfer a pixel with the `ComponentSampleModel.getDataElements(int, int, Object, DataBuffer)` and `ComponentSampleModel.setDataElements(int, int, Object, DataBuffer)` methods.
`int`
`getOffset(int x, int y)`
Gets the offset for the first band of pixel (x,y).
`int`
`getOffset(int x, int y, int b)`
Gets the offset for band b of pixel (x,y).
`int[]`
`getPixel(int x, int y, int[] iArray, DataBuffer data)`
Returns the samples for a specified pixel in an int array, one sample per array element.
`int[]`
`getPixels(int x, int y, int w, int h, int[] iArray, DataBuffer data)`
Returns all samples for a rectangle of pixels in an int array, one sample per array element.
`final int`
`getPixelStride()`
Returns the pixel stride of this ComponentSampleModel.
`int`
`getSample(int x, int y, int b, DataBuffer data)`
Returns the sample in a specified band for the pixel located at (x,y) as an int.
`double`
`getSampleDouble(int x, int y, int b, DataBuffer data)`
Returns the sample in a specified band for a pixel located at (x,y) as a double.
`float`
`getSampleFloat(int x, int y, int b, DataBuffer data)`
Returns the sample in a specified band for the pixel located at (x,y) as a float.
`int[]`
`getSamples(int x, int y, int w, int h, int b, int[] iArray, DataBuffer data)`
Returns the samples for a specified band for the specified rectangle of pixels in an int array, one sample per array element.
`final int[]`
`getSampleSize()`
Returns the number of bits per sample for all bands.
`final int`
`getSampleSize(int band)`
Returns the number of bits per sample for the specified band.
`final int`
`getScanlineStride()`
Returns the scanline stride of this ComponentSampleModel.
`void`
`setDataElements(int x, int y, Object obj, DataBuffer data)`
Sets the data for a single pixel in the specified `DataBuffer` from a primitive array of type `TransferType`.
`void`
`setPixel(int x, int y, int[] iArray, DataBuffer data)`
Sets a pixel in the DataBuffer using an int array of samples for input.
`void`
`setPixels(int x, int y, int w, int h, int[] iArray, DataBuffer data)`
Sets all samples for a rectangle of pixels from an int array containing one sample per array element.
`void`
`setSample(int x, int y, int b, double s, DataBuffer data)`
Sets a sample in the specified band for the pixel located at (x,y) in the DataBuffer using a double for input.
`void`
`setSample(int x, int y, int b, float s, DataBuffer data)`
Sets a sample in the specified band for the pixel located at (x,y) in the DataBuffer using a float for input.
`void`
`setSample(int x, int y, int b, int s, DataBuffer data)`
Sets a sample in the specified band for the pixel located at (x,y) in the DataBuffer using an int for input.
`void`
`setSamples(int x, int y, int w, int h, int b, int[] iArray, DataBuffer data)`
Sets the samples in the specified band for the specified rectangle of pixels from an int array containing one sample per array element.

### Methods declared in class SampleModel

`getDataElements, getDataType, getHeight, getNumBands, getPixel, getPixel, getPixels, getPixels, getSamples, getSamples, getTransferType, getWidth, setDataElements, setPixel, setPixel, setPixels, setPixels, setSamples, setSamples`
Modifier and Type
Method
Description
`Object`
`getDataElements(int x, int y, int w, int h, Object obj, DataBuffer data)`
Returns the pixel data for the specified rectangle of pixels in a primitive array of type TransferType.
`final int`
`getDataType()`
Returns the data type of the DataBuffer storing the pixel data.
`final int`
`getHeight()`
Returns the height in pixels.
`final int`
`getNumBands()`
Returns the total number of bands of image data.
`double[]`
`getPixel(int x, int y, double[] dArray, DataBuffer data)`
Returns the samples for the specified pixel in an array of double.
`float[]`
`getPixel(int x, int y, float[] fArray, DataBuffer data)`
Returns the samples for the specified pixel in an array of float.
`double[]`
`getPixels(int x, int y, int w, int h, double[] dArray, DataBuffer data)`
Returns all samples for a rectangle of pixels in a double array, one sample per array element.
`float[]`
`getPixels(int x, int y, int w, int h, float[] fArray, DataBuffer data)`
Returns all samples for a rectangle of pixels in a float array, one sample per array element.
`double[]`
`getSamples(int x, int y, int w, int h, int b, double[] dArray, DataBuffer data)`
Returns the samples for a specified band for a specified rectangle of pixels in a double array, one sample per array element.
`float[]`
`getSamples(int x, int y, int w, int h, int b, float[] fArray, DataBuffer data)`
Returns the samples for a specified band for the specified rectangle of pixels in a float array, one sample per array element.
`int`
`getTransferType()`
Returns the TransferType used to transfer pixels via the getDataElements and setDataElements methods.
`final int`
`getWidth()`
Returns the width in pixels.
`void`
`setDataElements(int x, int y, int w, int h, Object obj, DataBuffer data)`
Sets the data for a rectangle of pixels in the specified DataBuffer from a primitive array of type TransferType.
`void`
`setPixel(int x, int y, double[] dArray, DataBuffer data)`
Sets a pixel in the DataBuffer using a double array of samples for input.
`void`
`setPixel(int x, int y, float[] fArray, DataBuffer data)`
Sets a pixel in the DataBuffer using a float array of samples for input.
`void`
`setPixels(int x, int y, int w, int h, double[] dArray, DataBuffer data)`
Sets all samples for a rectangle of pixels from a double array containing one sample per array element.
`void`
`setPixels(int x, int y, int w, int h, float[] fArray, DataBuffer data)`
Sets all samples for a rectangle of pixels from a float array containing one sample per array element.
`void`
`setSamples(int x, int y, int w, int h, int b, double[] dArray, DataBuffer data)`
Sets the samples in the specified band for the specified rectangle of pixels from a double array containing one sample per array element.
`void`
`setSamples(int x, int y, int w, int h, int b, float[] fArray, DataBuffer data)`
Sets the samples in the specified band for the specified rectangle of pixels from a float array containing one sample per array element.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`String`
`toString()`
Returns a string representation of the object.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Constructor Details

### PixelInterleavedSampleModel

public PixelInterleavedSampleModel(int dataType, int w, int h, int pixelStride, int scanlineStride, int[] bandOffsets)
Constructs a PixelInterleavedSampleModel with the specified parameters. The number of bands will be given by the length of the bandOffsets array.

Parameters:
  `dataType` - The data type for storing samples.
  `w` - The width (in pixels) of the region of image data described.
  `h` - The height (in pixels) of the region of image data described.
  `pixelStride` - The pixel stride of the image data.
  `scanlineStride` - The line stride of the image data.
  `bandOffsets` - The offsets of all bands.
Throws:
  `IllegalArgumentException` - if `w` or `h` is not greater than 0
  `IllegalArgumentException` - if any offset between bands is greater than the scanline stride
  `IllegalArgumentException` - if the product of `pixelStride` and `w` is greater than `scanlineStride`
  `IllegalArgumentException` - if `pixelStride` is less than any offset between bands
  `IllegalArgumentException` - if `dataType` is not one of the supported data types

## Method Details

### createCompatibleSampleModel

public SampleModel createCompatibleSampleModel(int w, int h)
Creates a new PixelInterleavedSampleModel with the specified width and height. The new PixelInterleavedSampleModel will have the same number of bands, storage data type, and pixel stride as this PixelInterleavedSampleModel. The band offsets may be compressed such that the minimum of all of the band offsets is zero.

Overrides:
  `createCompatibleSampleModel` in class `ComponentSampleModel`
Parameters:
  `w` - the width of the resulting `SampleModel`
  `h` - the height of the resulting `SampleModel`
Returns:
  a new `SampleModel` with the specified width and height.
Throws:
  `IllegalArgumentException` - if `w` or `h` is not greater than 0

### createSubsetSampleModel

public SampleModel createSubsetSampleModel(int[] bands)
Creates a new PixelInterleavedSampleModel with a subset of the bands of this PixelInterleavedSampleModel. The new PixelInterleavedSampleModel can be used with any DataBuffer that the existing PixelInterleavedSampleModel can be used with. The new PixelInterleavedSampleModel/DataBuffer combination will represent an image with a subset of the bands of the original PixelInterleavedSampleModel/DataBuffer combination.

Overrides:
  `createSubsetSampleModel` in class `ComponentSampleModel`
Parameters:
  `bands` - a subset of bands from this `ComponentSampleModel`
Returns:
  a `ComponentSampleModel` created with a subset of bands from this `ComponentSampleModel`.